<script>
  // Imports
  import { json } from "d3-fetch";
  import { onMount } from "svelte";
  import { max } from "d3-array";

  import Controls from "./_control.svelte";
  import Line from "./_line.svelte";

  // Size and margins
  const width = 600;
  const height = 420;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Load the data
  let datapoints = null;
  let buildingtypes = null;
  let selection = null;
  let maxEnergy = null;
  let bindLocation = "Baltimore";
  let bindScaling = 1;
  onMount(async () => {
    datapoints = await json("/data/hourly_heating_december.json");
    buildingtypes = [... new Set (datapoints.map(d => d.buildingtype))];
  });

  //Creating the function
  function wrangleData(dataset, loc) {
    if (dataset != null) {
      selection = dataset.filter(d => d.city == loc);
    }
  }

// Select data
function selectData(type, datafile) {
    return datafile.filter(d => d.buildingtype == type)
  }

  $: wrangleData(datapoints, bindLocation);
</script>

{#if !datapoints}
  <p>Loading the data, please wait...</p>
{:else}
  <div transform="translate(0,150)">
    <div transform="translate(0,50)">
      <Controls bind:location={bindLocation} bind:scaling={bindScaling}/>
    </div>
    <svg {width} {height}>
      <g transform="translate({margin.left}, {margin.top})">
            {#each buildingtypes as type, i}
              <g transform="translate(125,{10+(i*25)})">
                  <Line dataset={selection} boolScaling={bindScaling} type={type}/>
              </g>
            {/each}  
      </g>
    </svg>
  </div>
{/if}

